VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DrawFrameControl example"
   ClientHeight    =   3615
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6135
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3615
   ScaleWidth      =   6135
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkOptions 
      Caption         =   "&Pushed"
      Height          =   255
      Index           =   4
      Left            =   5040
      TabIndex        =   8
      Top             =   840
      Width           =   855
   End
   Begin VB.CheckBox chkOptions 
      Caption         =   "&Mono"
      Height          =   255
      Index           =   3
      Left            =   5040
      TabIndex        =   7
      Top             =   480
      Width           =   735
   End
   Begin VB.CheckBox chkOptions 
      Caption         =   "I&nactive"
      Height          =   255
      Index           =   2
      Left            =   3480
      TabIndex        =   6
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CheckBox chkOptions 
      Caption         =   "&Flat"
      Height          =   255
      Index           =   1
      Left            =   3480
      TabIndex        =   5
      Top             =   840
      Width           =   1335
   End
   Begin VB.CheckBox chkOptions 
      Caption         =   "&Checked"
      Height          =   255
      Index           =   0
      Left            =   3480
      TabIndex        =   4
      Top             =   480
      Width           =   1335
   End
   Begin VB.PictureBox picFrameImage 
      BorderStyle     =   0  'None
      Height          =   1455
      Index           =   3
      Left            =   3480
      ScaleHeight     =   1455
      ScaleWidth      =   1455
      TabIndex        =   12
      TabStop         =   0   'False
      Top             =   1920
      Width           =   1455
   End
   Begin VB.PictureBox picFrameImage 
      BorderStyle     =   0  'None
      Height          =   855
      Index           =   2
      Left            =   2280
      ScaleHeight     =   855
      ScaleWidth      =   855
      TabIndex        =   11
      TabStop         =   0   'False
      Top             =   1920
      Width           =   855
   End
   Begin VB.PictureBox picFrameImage 
      BorderStyle     =   0  'None
      Height          =   495
      Index           =   1
      Left            =   1440
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   1920
      Width           =   495
   End
   Begin VB.PictureBox picFrameImage 
      BorderStyle     =   0  'None
      Height          =   255
      Index           =   0
      Left            =   840
      ScaleHeight     =   255
      ScaleWidth      =   255
      TabIndex        =   9
      TabStop         =   0   'False
      Top             =   1920
      Width           =   255
   End
   Begin VB.ComboBox cboImageType 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   1200
      Width           =   2655
   End
   Begin VB.ComboBox cboFrameType 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   480
      Width           =   2655
   End
   Begin VB.Label lblText 
      Caption         =   "Frame &image:"
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   2
      Top             =   960
      Width           =   1575
   End
   Begin VB.Label lblText 
      Caption         =   "Frame &type:"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1575
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function DrawFrameControl Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long

Private Const DFC_CAPTION = 1
Private Const DFC_MENU = 2
Private Const DFC_SCROLL = 3
Private Const DFC_BUTTON = 4

Private Const DFCS_INACTIVE = &H100
Private Const DFCS_PUSHED = &H200
Private Const DFCS_CHECKED = &H400
Private Const DFCS_FLAT = &H4000
Private Const DFCS_MONO = &H8000
Private Const DFCS_ADJUSTRECT = &H2000

Private Const DFCS_BUTTONCHECK = &H0
Private Const DFCS_BUTTONRADIOIMAGE = &H1
Private Const DFCS_BUTTONRADIOMASK = &H2
Private Const DFCS_BUTTONRADIO = &H4
Private Const DFCS_BUTTON3STATE = &H8
Private Const DFCS_BUTTONPUSH = &H10

Private Const DFCS_CAPTIONCLOSE = &H0
Private Const DFCS_CAPTIONMIN = &H1
Private Const DFCS_CAPTIONMAX = &H2
Private Const DFCS_CAPTIONRESTORE = &H3
Private Const DFCS_CAPTIONHELP = &H4

Private Const DFCS_MENUARROW = &H0
Private Const DFCS_MENUCHECK = &H1
Private Const DFCS_MENUBULLET = &H2
Private Const DFCS_MENUARROWRIGHT = &H4

Private Const DFCS_SCROLLUP = &H0
Private Const DFCS_SCROLLDOWN = &H1
Private Const DFCS_SCROLLLEFT = &H2
Private Const DFCS_SCROLLRIGHT = &H3
Private Const DFCS_SCROLLCOMBOBOX = &H5
Private Const DFCS_SCROLLSIZEGRIP = &H8
Private Const DFCS_SCROLLSIZEGRIPRIGHT = &H10

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type


Private Sub cboFrameType_Click()
    
    'The user changed the frame type.
    'Repopulate the image type depending on the new frame type
    
    With cboImageType
        
        'Clear any existing items in the image type combobox
        .Clear
        
        Select Case cboFrameType.ItemData(cboFrameType.ListIndex)
        
            Case DFC_BUTTON
                'The user selected the "Button" frame type
                .AddItem "Check"
                .ItemData(.NewIndex) = DFCS_BUTTONCHECK
                .AddItem "Radio image"
                .ItemData(.NewIndex) = DFCS_BUTTONRADIOIMAGE
                .AddItem "Radio mask"
                .ItemData(.NewIndex) = DFCS_BUTTONRADIOMASK
                .AddItem "Radio"
                .ItemData(.NewIndex) = DFCS_BUTTONRADIO
                .AddItem "3-state"
                .ItemData(.NewIndex) = DFCS_BUTTON3STATE
                .AddItem "Push"
                .ItemData(.NewIndex) = DFCS_BUTTONPUSH
                
            Case DFC_CAPTION
                .AddItem "Close"
                .ItemData(.NewIndex) = DFCS_CAPTIONCLOSE
                .AddItem "Min"
                .ItemData(.NewIndex) = DFCS_CAPTIONMIN
                .AddItem "Max"
                .ItemData(.NewIndex) = DFCS_CAPTIONMAX
                .AddItem "Restore"
                .ItemData(.NewIndex) = DFCS_CAPTIONRESTORE
                .AddItem "Help"
                .ItemData(.NewIndex) = DFCS_CAPTIONHELP
                
            Case DFC_MENU
                .AddItem "Arrow"
                .ItemData(.NewIndex) = DFCS_MENUARROW
                .AddItem "Check"
                .ItemData(.NewIndex) = DFCS_MENUCHECK
                .AddItem "Bullet"
                .ItemData(.NewIndex) = DFCS_MENUBULLET
                .AddItem "Arrow right"
                .ItemData(.NewIndex) = DFCS_MENUARROWRIGHT
                
            Case DFC_SCROLL
                .AddItem "Scroll up"
                .ItemData(.NewIndex) = DFCS_SCROLLUP
                .AddItem "Scroll down"
                .ItemData(.NewIndex) = DFCS_SCROLLDOWN
                .AddItem "Scroll left"
                .ItemData(.NewIndex) = DFCS_SCROLLLEFT
                .AddItem "Scroll right"
                .ItemData(.NewIndex) = DFCS_SCROLLRIGHT
                .AddItem "Scroll combobox"
                .ItemData(.NewIndex) = DFCS_SCROLLCOMBOBOX
                .AddItem "Scroll size grip"
                .ItemData(.NewIndex) = DFCS_SCROLLSIZEGRIP
                .AddItem "Scroll size grip right"
                .ItemData(.NewIndex) = DFCS_SCROLLSIZEGRIPRIGHT
        End Select
        
        'Set to the first item in the list
        .ListIndex = 0
        
    End With

End Sub


Private Sub cboImageType_Click()

    'Redraw the frames to reflect the new setting
    DrawFrame

End Sub


Private Sub chkOptions_Click(Index As Integer)

    'Redraw the frames to reflect the new options
    DrawFrame
    
End Sub


Private Sub Form_Load()

    'Display myself immediately so that the first frame can be painted
    Show
    
    With cboFrameType
        'Set the combo items for the different types of frame
        .AddItem "Caption"
        .ItemData(.NewIndex) = DFC_CAPTION
        .AddItem "Menu"
        .ItemData(.NewIndex) = DFC_MENU
        .AddItem "Scroll"
        .ItemData(.NewIndex) = DFC_SCROLL
        .AddItem "Button"
        .ItemData(.NewIndex) = DFC_BUTTON
        
        'Set a default frame type
        .ListIndex = 0
    End With

End Sub


Private Sub DrawFrame()

    Dim iLoop As Integer
    Dim udtRect As RECT
    Dim lModifier As Long
    
    'Ensure the form is tidied up before we start drawing on it
    Me.Refresh
    DoEvents
    
    'Calculate the flags specified from the comboboxes
    If chkOptions(0).Value = vbChecked Then lModifier = DFCS_CHECKED
    If chkOptions(1).Value = vbChecked Then lModifier = lModifier Or DFCS_FLAT
    If chkOptions(2).Value = vbChecked Then lModifier = lModifier Or DFCS_INACTIVE
    If chkOptions(3).Value = vbChecked Then lModifier = lModifier Or DFCS_MONO
    If chkOptions(4).Value = vbChecked Then lModifier = lModifier Or DFCS_PUSHED
    
    'Loop for each of the pictureboxes on the form
    For iLoop = 0 To 3
    
        With picFrameImage(iLoop)
        
            'Read the dimensions of the picturebox into a RECT structure
            udtRect.Left = 0
            udtRect.Top = 0
            udtRect.Right = .Width / Screen.TwipsPerPixelX
            udtRect.Bottom = .Height / Screen.TwipsPerPixelY
            
            'Draw the frame control image
            DrawFrameControl .hDC, udtRect, _
                        cboFrameType.ItemData(cboFrameType.ListIndex), _
                        cboImageType.ItemData(cboImageType.ListIndex) Or lModifier
            
        End With
    
    Next

End Sub

